#ifndef RAYCREATOR
#define RAYCREATOR

#include "ray.h"
#include "point.h"
#include "lasso.h"
#include "real.h"

typedef struct{
  int resolution;
  Ranges * ranges;
  real_t fov;

  Coord eye;
  Coord forward;
  Coord right;
  Coord up;

} Raycreator;

Raycreator* init_raycreator(Ranges* ranges);
void create_rays(Raycreator* rc, Ray* rays);
void find_intersections(Ray* ray, Ranges* ranges);
void update_camera(Raycreator* rc, Lasso lasso);

#endif
