#ifndef ROOT
#define ROOT

#include "point.h"
#include "real.h"

typedef struct{
  void* s;
  Ranges ranges;

  void (*insert_points)(void* s, PointList* pl);
  void (*finalize)(void* s);
  real_t (*get_intensity_for_pos)(void* s, Coord pos);
  void (*launch_kernel)(void* s);
  long int (*get_memory_useage)(void* s);
} Root;

Root* create_root(Ranges* ranges);

#endif
